package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"
)

func WrapTaskDatalistHandler(ctx *gin.Context) {
	handler := newTaskDatalistHandler(ctx)
	baseRun(handler)
}

type TaskDatalist struct {
	ctx  *gin.Context
	req  *http_model.TaskDatalistRequest
	resp *http_model.CommonResponse
}

func (c TaskDatalist) getContext() *gin.Context {
	return c.ctx
}

func (c TaskDatalist) getResponse() interface{} {
	return c.resp
}

func (c TaskDatalist) getRequest() interface{} {
	return c.req
}

func (c TaskDatalist) run() {
	data := http_model.TaskDatalistRequest{}
	data = *c.req
	res, err := service.Task.GetTaskDatalist(c.ctx, data)
	if err != nil {
		logrus.Errorf("[GetTaskDatalist] call GetTaskDatalist err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorParamCheck, "")
		logrus.Info("GetTaskDatalist fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功查询数据待审列表"
	c.resp.Data = res
	c.resp.Status = consts.ErrorSuccess
}

func (c TaskDatalist) checkParam() error {
	return nil
}

func newTaskDatalistHandler(ctx *gin.Context) *TaskDatalist {
	return &TaskDatalist{
		ctx:  ctx,
		req:  http_model.NewTaskDatalistRequest(),
		resp: http_model.NewTaskDatalistResponse(),
	}
}
